#ifndef __myGL_h__
#define __myGL_h__

#include <GL/glut.h>
#include <math.h>

#define PI 3.14159265

void triangle();
void carree();
void cercle(int n); //nb d'angle

void tetraedre();
void cube();
void cone(int n); //nombre d'angle
void cylindre(int n); //nombre d'angle
void sphere( int p, int m);
/*
	p: nb parallele (sera multiplier par deux, car dessine deux demi sphere)
	m: nb de meridien
*/
void tore(int n, int p, double r);
/*
	n: nb de moreaux de cylindre
	p: nb de face par cylindre
	r: rayon du cylindre
*/

void Sierpinski(int n); //profondeur de Sierpinski
void Sierpinski3D(int n); //profondeur de Sierpinski en 3D

void Menger(int n); //profondeur de Menger
void Menger3D(int n); //profondeur de Menger en 3D

#endif